-- PSP Resolution: 480 × 272

-- Colours
blank = Color.create(0,0,0,0)
clear_col = Color.create(32,32,32,255)
grey = Color.create(50,50,50,255)
white = Color.create(255, 255, 255, 255)
red = Color.create(255, 0, 0, 255)
pink = Color.create(255, 0, 0, 255)
blue = Color.create(0, 0, 255, 255)
green = Color.create(0, 120, 0, 255)
purple = Color.create(221, 191, 216, 255)
yellow = Color.create(255, 255, 0, 255)

-- Set background colour`
Graphics.set_clear_color(green)

-- Data
lives = 3

enemyCounter = 10

playerY = 80
playerX = 68

enemyY = 80
enemyX = 480
enemySpeed = 272.0

-- Textures
--texture = Texture.load(nil, 0, 0)
--sprite = Sprite.create(240, 136, 256, 256, texture)

-- Transforms
playerTransform = Transform.create()
playerTransform:set_scale(64, 32)

enemyTransform = Transform.create()
enemyTransform:set_scale(64, 32)

roadTransform0 = Transform.create()
roadTransform0:set_scale(480, 80)
roadTransform0:set_position(240, 80)

roadTransform1 = Transform.create()
roadTransform1:set_scale(480, 80)
roadTransform1:set_position(240, 182)

function resetEnemy()
    enemyX = 480
    randNum = math.random(0, 1)
    if randNum == 0 then
        enemyY = 80
    else
        enemyY = 182
    end
end

function increaseEnemySpeed(speed)
    speed = speed * 2 -- Double the speed each time!
end

function update(dt)
    -- Reset Game
    if Input.button_pressed(PSP_START) then
        lives = 3
        enemyCounter = 10
        Graphics.set_clear_color(green)
        playerY = 80
        enemyY = 80
        enemySpeed = 272.0
    end

    -- win/lose conditions
    if enemyCounter <= 0 then
        Graphics.set_clear_color(blue)
        enemyY = 500
    elseif lives <= 0 then
        Graphics.set_clear_color(red)
        playerY = 500
    else
        -- Movement
        -- Input Y
        if Input.button_pressed(PSP_UP) then
            playerY = 182
        end
        if Input.button_held(PSP_DOWN) then
            playerY = 80
        end

        enemyX = enemyX - dt * enemySpeed

        -- player pos
        playerTransform:set_position(playerX, playerY)

        -- enemy pos
        enemyTransform:set_position(enemyX, enemyY)

        -- Enemy reaches end of road
        if enemyX < 0 then
            resetEnemy()
            enemySpeed = enemySpeed * 1.2
            if enemySpeed > 850 then
                enemySpeed = 850
                -- Decrease enemy counter if at max speed!
                enemyCounter = enemyCounter - 1
            end
        end

        -- Player is hit
        if enemyY == playerY and enemyX <= playerX then
            resetEnemy()
            lives = lives - 1
        end
    end
end

function draw()
    -- Top road
    Primitive.draw_rectangle(roadTransform0, grey)
    -- Bottom road
    Primitive.draw_rectangle(roadTransform1, grey)

    -- Draw player
    Primitive.draw_rectangle(playerTransform, blue)
    
    -- Draw enemy
    Primitive.draw_rectangle(enemyTransform, red)

    -- Lives
    for i = 1, lives, 1 do
        Primitive.draw_triangle(50 * i, 250, 25, 25, pink, 180)
    end

    -- Enemy counters
    for i = 1, enemyCounter, 1 do
        Primitive.draw_triangle(50 * i, 20, 10, 10, yellow, 180)
    end

end

time = Timer.create()
while QuickGame.running() do

    Input.update()

    update(time:delta())

    Graphics.start_frame()
    Graphics.clear()

    draw()
    
    Graphics.end_frame(true)
end